<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 04/11/2004 *
 * ================                             Last change: 08/12/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-config_payouts.php                          *
 * -------------------------------------------------------------------- *
 * Short description : Configure payout types                           *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Auszahlungensarten editieren                     *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!IS_ADMIN())) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), '/inc') + 4) . '/security.php';
	require($INC);
}

// Add description as navigation point
ADD_DESCR('admin', __FILE__);

if (REQUEST_ISSET_POST(('rate'))) REQUEST_SET_POST('rate', REVERT_COMMA(REQUEST_POST('rate')));

if ((REQUEST_ISSET_POST(('add'))) && (REQUEST_ISSET_POST(('title'))) && (REQUEST_POST('rate') > 0)) {
	// Add new payout type
	$result = SQL_QUERY_ESC("SELECT id FROM `{!_MYSQL_PREFIX!}_payout_types` WHERE type='%s' LIMIT 1",
		array(REQUEST_POST('title')), __FILE__, __LINE__);
	if (SQL_NUMROWS($result) == 0) {
		// Add now
		SQL_QUERY_ESC("INSERT INTO `{!_MYSQL_PREFIX!}_payout_types`
(type, rate, min_points, from_account, from_pass, engine_url, engine_ret_ok, engine_ret_failed, pass_enc, allow_url)
VALUES ('%s', %d, %d,'%s','%s','%s','%s','%s','%s','%s')",
 array(
	REQUEST_POST('title'),
	bigintval(REQUEST_POST('rate')),
	bigintval(REQUEST_POST('mpoi')),
	REQUEST_POST('yacc'),
	REQUEST_POST('ypass'),
	REQUEST_POST('yurl'),
	REQUEST_POST('yrdone'),
	REQUEST_POST('yrfailed'),
	REQUEST_POST('ytrans'),
	REQUEST_POST('allow_url'),
), __FILE__, __LINE__);
		$msg = getMessage('ADMIN_PAYOUT_TYPE_ADDED');
	} else {
		// Free memory
		SQL_FREERESULT($result);

		// Does already exist
		$msg = "<div class=\"admin_failed\">{--ADMIN_PAYOUT_TYPE_ALREADY--}</div>";
	}
}

// Payout requests by your members
$result_mem = SQL_QUERY("SELECT id FROM `{!_MYSQL_PREFIX!}_user_payouts` WHERE `status`='NEW' ORDER BY payout_timestamp DESC", __FILE__, __LINE__);

$display = true;
if ((REQUEST_ISSET_POST('edit')) && (SELECTION_COUNT(REQUEST_POST('sel')) > 0)) {
	// Edit payout types
	if ((REQUEST_ISSET_GET('ok')) && (REQUEST_GET('ok') == "ok")) {
		// Init SQLs
		INIT_SQLS();

		// Edit entries
		foreach (REQUEST_POST('sel') as $id => $sel) {
			// Secure ID
			$id = bigintval($id);

			// Edit only if something is entered
			if ((REQUEST_ISSET_POST(('title', $id))) && (REQUEST_POST('rate', $id) > 0)) {
				// Update entry
				ADD_SQL(SQL_QUERY_ESC("UPDATE `{!_MYSQL_PREFIX!}_payout_types` SET
type='%s',
rate=%s,
min_points=%s,
allow_url='%s'
WHERE id='".$id."' LIMIT 1",
 array(
	REQUEST_POST('title', $id),
	REVERT_COMMA(REQUEST_POST('rate', $id)),
	REVERT_COMMA(REQUEST_POST('mpoi' , $id)),
	REQUEST_POST('allow', $id),
),__FILE__, __LINE__, false));
			}
		}

		// Run all SQLs
		runFilterChain('run_sqls');

		// Get message
		$msg = getMessage('ADMIN_PAYOUT_ENTRIES_CHANGED');
	} else {
		$display = false; //Suppress any other outputs
		$OUT = ''; $SW = 2;
		foreach (REQUEST_POST('sel') as $id => $sel) {
			// Load data
			$result = SQL_QUERY_ESC("SELECT type, rate, min_points, allow_url FROM `{!_MYSQL_PREFIX!}_payout_types` WHERE id=%s LIMIT 1",
				array(bigintval($id)), __FILE__, __LINE__);
			list($title, $rate, $mpoi, $allow) = SQL_FETCHROW($result);
			SQL_FREERESULT($result);

			// Prepare data for the row template
			$content = array(
				'sw'    => $SW,
				'id'    => $id,
				'title' => COMPILE_CODE($title),
				'rate'  => TRANSLATE_COMMA($rate),
				'mpoi'  => TRANSLATE_COMMA($mpoi),
				'allow' => ADD_SELECTION('yn', $allow, "allow[".$id."]"),
			);

			// Load row template and switch color
			$OUT .= LOAD_TEMPLATE("admin_config_payouts_edit_row", true, $content);
			$SW = 3 - $SW;
		}

		// @TODO Rewrite this constant
		define('__PAYOUT_ROWS', $OUT);

		// Load main template
		LOAD_TEMPLATE("admin_config_payouts_edit");
	}
} elseif ((REQUEST_ISSET_POST('del')) && (SELECTION_COUNT(REQUEST_POST('sel')) > 0)) {
	// Delete payout types
	if ((REQUEST_ISSET_GET('ok')) && (REQUEST_GET('ok') == "ok")) {
		// Init SQLs
		INIT_SQLS();

		// Delete entries
		foreach (REQUEST_POST('sel') as $id => $sel) {
			ADD_SQL(SQL_QUERY_ESC("DELETE LOW_PRIORITY FROM `{!_MYSQL_PREFIX!}_payout_types` WHERE id=%s LIMIT 1",
				array(bigintval($id)), __FILE__, __LINE__, false));
		} // END - foreach

		// Run all SQLs
		runFilterChain('run_sqls');

		// Get message
		$msg = getMessage('ADMIN_PAYOUT_ENTRIES_DELETED');
	} else {
		$display = false; //Suppress any other outputs
		$OUT = ''; $SW = 2;
		foreach (REQUEST_POST('sel') as $id => $sel) {
			// Secure ID number
			$id = bigintval($id);

			// Load data
			$result = SQL_QUERY_ESC("SELECT type, rate, min_points FROM `{!_MYSQL_PREFIX!}_payout_types` WHERE id=%s LIMIT 1",
				array($id), __FILE__, __LINE__);
			list($title, $rate, $mpoi) = SQL_FETCHROW($result);
			SQL_FREERESULT($result);

			// Prepare data for the row template
			$content = array(
				'sw'    => $SW,
				'id'    => $id,
				'title' => COMPILE_CODE($title),
				'rate'  => TRANSLATE_COMMA($rate),
				'mpoi'  => TRANSLATE_COMMA($mpoi),
			);

			// Load row template and switch color
			$OUT .= LOAD_TEMPLATE("admin_config_payouts_del_row", true, $content);
			$SW = 3 - $SW;
		}
		define('__PAYOUT_ROWS', $OUT);

		// Load main template
		LOAD_TEMPLATE("admin_config_payouts_del");
	}
}

if (!empty($msg)) {
	// Output message
	LOAD_TEMPLATE('admin_settings_saved', false, $msg);
}

// Payout types
$result_type = SQL_QUERY("SELECT id, type, rate, min_points, from_account FROM `{!_MYSQL_PREFIX!}_payout_types` ORDER BY type", __FILE__, __LINE__);

if ((SQL_NUMROWS($result_type) > 0) && ($display)) {
	// List all payout types
	$OUT = ''; $SW = 2;
	while ($content = SQL_FETCHARRAY($result_type)) {
		// Prepare data for the row template
		$content = array(
			'sw'    => $SW,
			'id'    => $content['id'],
			'from'  => COMPILE_CODE($content['from_account']),
			'type'  => COMPILE_CODE($content['type']),
			'rate'  => TRANSLATE_COMMA($content['rate']),
			'mpoi'  => TRANSLATE_COMMA($content['min_points']),
		);

		// Load row template and switch color
		$OUT .= LOAD_TEMPLATE("admin_config_payouts_row", true, $content);
		$SW = 3 - $SW;
	}

	// Free memory
	SQL_FREERESULT($result_type);

	// @TODO Rewrite this constant
	define('__PAYOUT_ROWS', $OUT);

	// Load main template
	LOAD_TEMPLATE("admin_config_payouts");
}

// Does your members request payouts?
if ((SQL_NUMROWS($result_mem) > 0) && ($display)) {
	// Members has requested payouts
	LOAD_TEMPLATE('admin_settings_saved', false, "<a href=\"{!URL!}/modules.php?module=admin&amp;what=list_payouts\">{--ADMIN_PAYOUT_LIST_REQUESTS--}</a></P>");
} elseif ($display) {
	// No member requests so far
	LOAD_TEMPLATE('admin_settings_saved', false, getMessage('ADMIN_PAYOUT_NO_MEMBER_REQUESTS'));
}

// Free result
SQL_FREERESULT($result_mem);

// Add new paypout type
if ($display) LOAD_TEMPLATE("admin_payout_add_new");

//
?>
