<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 04/24/2004 *
 * ================                             Last change: 04/24/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-repair_cats.php                             *
 * -------------------------------------------------------------------- *
 * Short description : Repairs category selections                      *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Repariert Kategorieauswahlen                     *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!IS_ADMIN())) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), '/inc') + 4) . '/security.php';
	require($INC);
}

// Add description as navigation point
ADD_DESCR('admin', __FILE__);

$result = SQL_QUERY("SELECT userid FROM `{!_MYSQL_PREFIX!}_user_cats` ORDER BY userid", __FILE__, __LINE__);
if (SQL_NUMROWS($result) > 0) {
	// Check if found userid is also found in user_data table
	$REMOVED = 0; // Nothing is removed for now... ;-)
	while ($content = SQL_FETCHARRAY($result)) {
		$result_user = SQL_QUERY_ESC("SELECT userid FROM `{!_MYSQL_PREFIX!}_user_data` WHERE userid=%s LIMIT 1",
			array(bigintval($content['userid'])), __FILE__, __LINE__);
		if (SQL_NUMROWS($result_user) == 0) {
			// Ok, we found something to remove
			SQL_QUERY_ESC("DELETE LOW_PRIORITY FROM `{!_MYSQL_PREFIX!}_user_cats` WHERE userid=%s",
				array(bigintval($content['userid'])), __FILE__, __LINE__);
			$REMOVED += SQL_AFFECTEDROWS();
		} else {
			// Free memory
			SQL_FREERESULT($result_user);
		}
	} // END - while

	// Free memory
	SQL_FREERESULT($result);

	if ($REMOVED > 0) {
		// Entries repaired
		$content = sprintf(getMessage('ADMIN_REPAIR_ENTRIES_FIXED'), $REMOVED);
	} else {
		// Nothing repaired
		$content = "<div class=\"admin_failed\">{--ADMIN_REPAIR_NOTHING_FIXED--}</div>";
	}
} else {
	// No category selections found, no members registered?
	$content = "<div class=\'admin_failed\">{--ADMIN_REPAIR_CATS_NOTHING--}</div>";
}

// Load template
LOAD_TEMPLATE('admin_settings_saved', false, $content);

//
?>
