<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 01/14/2005 *
 * ================                             Last change: 01/14/2005 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-usr_online.php                              *
 * -------------------------------------------------------------------- *
 * Short description : Who is where? (DO NOT add sub menus!)            *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Wer ist wo? (KEINE Untermenues anhaengen!)       *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!IS_ADMIN())) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), '/inc') + 4) . '/security.php';
	require($INC);
}

// Add description as navigation point
ADD_DESCR('admin', __FILE__);

// Online stats are only working if extension ext-online is installed
if (EXT_IS_ACTIVE('online')) {
	// Count guests, members and admins
	// @TODO Rewrite these constants
	// @TODO Add a filter for sponsor
	define('_GUESTS_ONLINE' , GET_TOTAL_DATA("N", 'online', "id", "is_admin", true, " AND is_member='N'"));
	define('_ADMINS_ONLINE' , GET_TOTAL_DATA("N", 'online', "id", "is_admin", true, " AND is_member='Y'"));
	define('_MEMBERS_ONLINE', GET_TOTAL_DATA("N", 'online', "id", "is_admin", true));

	// Load template
	LOAD_TEMPLATE("admin_mini_online");

	// Check for online users
	$result = SQL_QUERY("SELECT id, ip, userid, refid, module, action, what, is_member, is_admin, timestamp FROM `{!_MYSQL_PREFIX!}_online` ORDER by timestamp DESC",
		__FILE__, __LINE__);
	if (SQL_NUMROWS($result) > 0) {
		// Load header template
		LOAD_TEMPLATE("admin_online_header");

		// List all online users
		$SW = 2;
		while ($content = SQL_FETCHARRAY($result)) {
			// Fix empty action/what
			if (empty($content['action'])) $content['action'] = '---';
			if (empty($content['what']))   $content['what']   = '---';

			if ($content['is_admin'] == 'Y') {
				// Is an administrator
				$content['userid'] = getMessage('_IS_ADMIN');
			} elseif (($content['is_member'] == 'N') && ($content['is_admin'] == 'N')) {
				// Is a guest
				$content['userid'] = getMessage('_IS_GUEST');
			} elseif ($content['userid'] > 0) {
				// Add profile link to userid
				$content['userid'] = ADMIN_USER_PROFILE_LINK($content['userid']);
			} // END - if

			// Is the refid set?
			if ($content['refid'] > 0) {
				// Add profile link to referer id
				$content['refid'] = ADMIN_USER_PROFILE_LINK($content['refid']);
			} // END - if

			OUTPUT_HTML("<tr>
  <td align=\"center\" width=\"5%\" class=\"switch_sw".$SW." bottom right\">".$content['id']."</td>
  <td align=\"center\" width=\"15%\" class=\"switch_sw".$SW." bottom right\">".$content['userid']."</td>
  <td align=\"center\" width=\"10%\" class=\"switch_sw".$SW." bottom right\">".$content['ip']."</td>
  <td align=\"center\" width=\"5%\" class=\"switch_sw".$SW." bottom right\">".$content['refid']."</td>
  <td align=\"center\" width=\"10%\" class=\"switch_sw".$SW." bottom right\">".$content['module']."</td>
  <td align=\"center\" width=\"10%\" class=\"switch_sw".$SW." bottom right\">".$content['action']."</td>
  <td align=\"center\" width=\"5%\" class=\"switch_sw".$SW." bottom right\">".$content['what']."</td>
  <td align=\"center\" width=\"10%\" class=\"switch_sw".$SW." bottom\">".MAKE_DATETIME($content['timestamp'], "2")."</td>
</tr>");
			$SW = 3 - $SW;
		} // END - while

		// Free memory
		SQL_FREERESULT($result);

		// @TODO Rewrite this constant
		define('__FANCY_ONLINE_TIMEOUT', CREATE_FANCY_TIME(getConfig('online_timeout')));

		// Load footer template
		LOAD_TEMPLATE("admin_online_footer");
	} // END - if
} else {
	// Online statistics deactivated!
	LOAD_TEMPLATE('admin_settings_saved', false, getMessage('ONLINE_STATISTICS_DEACTIVATED'));
}

//
?>
