<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 11/26/2004 *
 * ================                             Last change: 11/26/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-active.php                                  *
 * -------------------------------------------------------------------- *
 * Short description : Today active members list                        *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Liste heutiger aktiver Mitglieder                *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), '/inc') + 4) . '/security.php';
	require($INC);
} elseif ((!EXT_IS_ACTIVE('active')) && (!IS_ADMIN())) {
	addFatalMessage(__FILE__, __LINE__, getMessage('EXTENSION_PROBLEM_EXT_INACTIVE'), 'active');
	return;
}

// Add description as navigation point
ADD_DESCR('guest', __FILE__);

// Extra field to include is by default uid
$add = 'userid';

// If nickname is installed the extra field is the nickname of the user
if (EXT_IS_ACTIVE('nickname')) $add = 'nickname';

// Check for members who were active only this day
$result = SQL_QUERY_ESC("SELECT userid, ".$add.", last_online
FROM `{!_MYSQL_PREFIX!}_user_data`
WHERE last_online >= %s AND `status`='CONFIRMED'
ORDER BY last_online DESC LIMIT %s",
	array(START_TDAY, getConfig('active_limit')), __FILE__, __LINE__);

// Entries found?
if (SQL_NUMROWS($result) > 0) {
	// At least one member was online so let's load them all
	$OUT = ''; $SW = 2;
	while (list($uid, $nick, $last) = SQL_FETCHROW($result)) {
		$nick2 = '---';
		if (($nick != $uid) && (!empty($nick))) $nick2 = $nick;

		// Transfer data to array
		$content = array(
			'sw'     => $SW,
			'uid'    => $uid,
			'nick'   => $nick2,
			'points' => TRANSLATE_COMMA(GET_TOTAL_DATA($uid, 'user_points', 'points') - GET_TOTAL_DATA($uid, 'user_data', 'used_points')),
			'last'   => MAKE_DATETIME($last, '2'),
		);

		// Load template
		$OUT .= LOAD_TEMPLATE('guest_active_row', true, $content);

		// Switch colors
		$SW = 3 - $SW;
	}
} else {
	// No member was online today! :-(
	$OUT = LOAD_TEMPLATE('guest_active_none_row', true);
}

// Remember output in constant
define('__ACTIVE_ROWS', $OUT);

// Load template
LOAD_TEMPLATE('guest_active_table');

//
?>
