<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 06/10/2005 *
 * ===============                              Last change: 05/18/2008 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-sponsor_infos.php                           *
 * -------------------------------------------------------------------- *
 * Short description : Informations and prices for the sponsor          *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Informationen/Preise fuer den Sponsoren          *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software. You can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License.       *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4)."/security.php";
	require($INC);
} elseif ((!EXT_IS_ACTIVE('sponsor'))) {
	addFatalMessage(__FILE__, __LINE__, getMessage('EXTENSION_PROBLEM_EXT_INACTIVE'), 'sponsor');
	return;
}

// Add description as navigation point
ADD_DESCR('guest', __FILE__);

// Init both results (see footer of this file)
$result_act = false;
$result_pay = false;

// Load all sponsor actions
$result_act = SQL_QUERY("SELECT DISTINCT m.title, c.conv_rate, c.conv_name
FROM `{!_MYSQL_PREFIX!}_sponsor_menu` AS m
LEFT JOIN `{!_MYSQL_PREFIX!}_sponsor_action_convert` AS c ON m.what=c.ext_name
LEFT JOIN `{!_MYSQL_PREFIX!}_sponsor_registry` AS r ON m.what=r.ext_name
WHERE m.`action`='actions' AND r.is_active='Y'
ORDER BY m.sort ASC", __FILE__, __LINE__);

if (SQL_NUMROWS($result_act) > 0) {
	// Load all actions
	$OUT_ACT = ''; $SW = 2;
	while ($content = SQL_FETCHARRAY($result_act)) {
		// Prepare data for the row template
		// @TODO Rewritings: conv->conv_rate,name->conv_name in template
		$content = array(
			'sw'    => $SW,
			'title' => $content['title'],
			'conv'  => round($content['conv_rate']),
			'name'  => $content['conv_name'],
		);

		// Load row template and switch color
		$OUT_ACT .= LOAD_TEMPLATE("guest_sponsor_act_row", true, $content);
		$SW = 3 - $SW;
	} // END - while

	// Check for pay types
	$result_pay = SQL_QUERY("SELECT pay_name, pay_rate, pay_min_count, pay_currency FROM `{!_MYSQL_PREFIX!}_sponsor_paytypes` ORDER BY pay_name", __FILE__, __LINE__);
	if (SQL_NUMROWS($result_pay) > 0) {
		// Load all pay types
		$OUT_PAY = ''; $SW = 2;
		while ($content = SQL_FETCHARRAY($result_pay)) {
			// Prepare data for the row template
			// @TODO Rewritings: name->pay_name,min->pay_min_count,min->pay_min_count,curr->pay_currency
			$content = array(
				'sw'    => $SW,
				'name'  => $content['pay_name'],
				'rate'  => TRANSLATE_COMMA($content['pay_rate']),
				'min'   => $content['pay_min_count'],
				'curr'  => $content['pay_currency'],
				'price' => TRANSLATE_COMMA($content['pay_min_count']),
			);

			// Load row template and switch color
			$OUT_PAY .= LOAD_TEMPLATE("guest_sponsor_pay_row", true, $content);
			$SW = 3 - $SW;
		}
	} else {
		// No pay types setuped so far!
		$OUT_PAY = LOAD_TEMPLATE("guest_sponsor_infos_none_row", LOAD_TEMPLATE('admin_settings_saved', true, getMessage('SPONSOR_NO_ACTIONS_ACTIVATED')));
	}
} else {
	// No actions activated so far!
	$OUT_ACT = LOAD_TEMPLATE("guest_sponsor_infos_none_row", LOAD_TEMPLATE('admin_settings_saved', true, getMessage('SPONSOR_NO_ACTIONS_ACTIVATED')));
	$OUT_PAY = LOAD_TEMPLATE("guest_sponsor_infos_none_row", LOAD_TEMPLATE('admin_settings_saved', true, getMessage('SPONSOR_NO_ACTIONS_ACTIVATED')));
}

// Free memory
SQL_FREERESULT($result_act);
SQL_FREERESULT($result_pay);

// Transfer rows to an array
$content = array(
	'actions'  => $OUT_ACT,
	'paytypes' => $OUT_PAY
);

// Load main template
LOAD_TEMPLATE("guest_sponsor_infos", false, $content);

//
?>
