<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 06/19/2004 *
 * ================                             Last change: 07/24/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-nickname.php                                *
 * -------------------------------------------------------------------- *
 * Short description : Nickname instead of the ID                       *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Nickname anstelle der ID                         *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), '/inc') + 4) . '/security.php';
	require($INC);
} elseif (!IS_MEMBER()) {
	LOAD_URL('modules.php?module=index');
} elseif ((!EXT_IS_ACTIVE('nickname')) && (!IS_ADMIN())) {
	addFatalMessage(__FILE__, __LINE__, getMessage('EXTENSION_PROBLEM_EXT_INACTIVE'), 'nickname');
	return;
}

// Add description as navigation point
ADD_DESCR('member', __FILE__);
$isValid = false;

if (IS_FORM_SENT()) {
	// Nickname was submitted so let's check if it is not already in use
	if (REQUEST_ISSET_POST(('nickname'))) {
		// Check if nickname is valid
		$PATTERN = "[".getConfig('nickname_pattern')."]{".getConfig('nickname_length').",}";
		if (ereg($PATTERN, REQUEST_POST('nickname'), $array)) {
			// Entered nickname is valid?
			if ($array[0] == REQUEST_POST('nickname')) $isValid = true;
		} // END - if
	} // END - if
} // END - if

if ($isValid === true) {
	// Look for nickname in database (we only need just one entry so don't worry about the "LIMIT 1" !
	$result = SQL_QUERY_ESC("SELECT userid FROM `{!_MYSQL_PREFIX!}_user_data` WHERE nickname='%s' AND userid != '%s' LIMIT 1",
		array(REQUEST_POST('nickname'), getUserId()), __FILE__, __LINE__);
	if (SQL_NUMROWS($result) == 0) {
		// Nickname not in use, so set it now
		SQL_QUERY_ESC("UPDATE `{!_MYSQL_PREFIX!}_user_data` SET nickname='%s' WHERE userid=%s LIMIT 1",
			array(REQUEST_POST('nickname'), getUserId()), __FILE__, __LINE__);
		$content = getMessage('NICKNAME_SAVED');
	} else {
		// Free result
		SQL_FREERESULT($result);

		// Nickname already in use!
		$content = getMessage('NICKNAME_ALREADY_IN_USE');
	}

	// Load template
	LOAD_TEMPLATE('admin_settings_saved', false, $content);
} else {
	// Load current nickname
	define('__NICKNAME', NICKNAME_GET_NICK(getUserId()));

	// Do we have already submit the form?
	if (REQUEST_ISSET_POST(('nickname'))) {
		LOAD_TEMPLATE('admin_settings_saved', false, "<div class=\"member_failed\">{--NICKNAME_IS_INVALID--}</div");
	} // END - if

	// Load Template
	LOAD_TEMPLATE("member_nickname_form");
}

//
?>
