<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 10/07/2004 *
 * ================                             Last change: 10/07/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-transfer.php                                *
 * -------------------------------------------------------------------- *
 * Short description : Point transfers                                  *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Punktetransfers                                  *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), '/inc') + 4) . '/security.php';
	require($INC);
} elseif (!IS_MEMBER()) {
	LOAD_URL('modules.php?module=index');
} elseif ((!EXT_IS_ACTIVE('transfer')) && (!IS_ADMIN())) {
	addFatalMessage(__FILE__, __LINE__, getMessage('EXTENSION_PROBLEM_EXT_INACTIVE'), 'transfer');
	return;
}

// Add description as navigation point
ADD_DESCR('member', __FILE__);

// Load data
$result = SQL_QUERY_ESC("SELECT opt_in FROM `{!_MYSQL_PREFIX!}_user_data` WHERE userid=%s LIMIT 1",
	array(getUserId()), __FILE__, __LINE__);
list($opt_in) = SQL_FETCHROW($result);

// Free memory
SQL_FREERESULT($result);

$mode = '';
if (REQUEST_ISSET_GET(('mode'))) $mode = REQUEST_GET('mode');

// Check for "faker"
if (($opt_in == 'N') && ($mode == "new")) $mode = '';

switch ($mode)
{
case "new": // Start new transfer
	// Get total points and subtract the balance amount from it = maximum transferable points
	$total = GET_TOTAL_DATA(getUserId(), "user_points", "points")  - GET_TOTAL_DATA(getUserId(), "user_data", "used_points");

	// Remember maximum value for template
	define('__TRANSFER_MAX_VALUE', round($total - getConfig('transfer_balance') - 0.5));

	if (IS_FORM_SENT()) {
		// Add new transfer
		if (getConfig('transfer_code') > 0) {
			// Check for code
			$code = generateRandomCodde(getConfig('transfer_code'), REQUEST_POST('code_chk'), getUserId(), constant('__TRANSFER_MAX_VALUE'));
			$valid_code = ($code == REQUEST_POST('code'));
		} else {
			// Zero length (= disabled) is always valid!
			$valid_code = true;
		}

		// Test password
		$valid_pass = ($pass == generateHash(REQUEST_POST('password'), $pass));

		// Test transfer amount
		$valid_amount = ((REQUEST_ISSET_POST(('points'))) && (REQUEST_POST('points') <= constant('__TRANSFER_MAX_VALUE')));

		// Test reason for transfer
		$valid_reason = (REQUEST_ISSET_POST(('reason')));

		// Test if a recipient is selected
		$valid_recipient = (REQUEST_POST('to_uid') > 0);

		// Check for nickname extension and set additional data
		$nick = false; $add = ", userid";
		if (EXT_IS_ACTIVE('nickname')) {
			$add = ", nickname";
			$nick = true;
		}

		// Re-check receivers and own personal data
		$result = SQL_QUERY_ESC("SELECT userid, gender, surname, family, email".$add." FROM `{!_MYSQL_PREFIX!}_user_data` WHERE userid IN ('%s','%s') AND `status`='CONFIRMED' ORDER BY userid LIMIT 2",
			array(getUserId(), bigintval(REQUEST_POST('to_uid'))), __FILE__, __LINE__);
		$valid_data = (SQL_NUMROWS($result) == 2);

		if ($valid_code && $valid_pass && $valid_amount && $valid_reason && $valid_recipient) {
			// Let's start the transfer and load user data
			list($uid1, $gender1, $sname1, $fname1, $email1, $nick1) = SQL_FETCHROW($result);
			list($uid2, $gender2, $sname2, $fname2, $email2, $nick2) = SQL_FETCHROW($result);
			SQL_FREERESULT($result);
			// @TODO Rewrite all these constants to array elements
			if ($uid1 == getUserId()) {
				// Data row 1 is sender's data
				define('__SENDER_GENDER'   , TRANSLATE_GENDER($gender1));
				define('__SENDER_NICK'     , $nick1);
				define('__SENDER_SNAME'    , $sname1);
				define('__SENDER_FNAME'    , $fname1);
				define('__SENDER_EMAIL'    , $email1);
				// Data row 2 is recpient's data
				define('__RECIPIENT_GENDER', TRANSLATE_GENDER($gender2));
				define('__RECIPIENT_NICK'  , $nick2);
				define('__RECIPIENT_SNAME' , $sname2);
				define('__RECIPIENT_FNAME' , $fname2);
				define('__RECIPIENT_EMAIL' , $email2);

				// Prepare variables for testing
				$TEST_NICK_SENDER = $nick1;
				$TEST_NICK_REC = $nick2;
			} else {
				// Data row 2 is sender's data
				define('__SENDER_GENDER'   , TRANSLATE_GENDER($gender2));
				define('__SENDER_NICK'     , $nick2);
				define('__SENDER_SNAME'    , $sname2);
				define('__SENDER_FNAME'    , $fname2);
				define('__SENDER_EMAIL'    , $email2);
				// Data row 1 is recpient's data
				define('__RECIPIENT_GENDER', TRANSLATE_GENDER($gender1));
				define('__RECIPIENT_NICK'  , $nick1);
				define('__RECIPIENT_SNAME' , $sname1);
				define('__RECIPIENT_FNAME' , $fname1);
				define('__RECIPIENT_EMAIL' , $email1);

				// Prepare variables for testing
				$TEST_NICK_SENDER = $nick2;
				$TEST_NICK_REC = $nick1;
			}

			// Sender's UID is always currently stored in cookie userid...
			define('__SENDER_UID'     , getUserId());
			define('__RECIPIENT_UID'  , REQUEST_POST('to_uid'));

			$SENDER = constant('__SENDER_UID');
			$RECIPIENT = constant('__RECIPIENT_UID');
			if ($nick) {
				if (($TEST_NICK_SENDER != constant('__SENDER_UID')) && (!empty($TEST_NICK_SENDER))) {
					$SENDER = constant('__SENDER_NICK');
				}

				if (($TEST_NICK_REC != constant('__RECIPIENT_UID')) && (!empty($TEST_NICK_REC))) {
					$RECIPIENT = constant('__RECIPIENT_NICK');
				}
			}

			// Remember transfer reason and fancy date/time in constants
			define('__TRANSFER_REASON', REQUEST_POST('reason'));
			define('__TRANSFER_EXPIRES', CREATE_FANCY_TIME(getConfig('transfer_age')));

			// Generate tranafer id
			define('__TRANS_ID', bigintval(generateRandomCodde("10", mt_rand(0, 99999), getUserId(), REQUEST_POST('reason'))));

			// Add entries to both tables
			SQL_QUERY_ESC("INSERT INTO `{!_MYSQL_PREFIX!}_user_transfers_in` (userid, from_uid, points, reason, time_trans, trans_id) VALUES ('%s','%s','%s','%s', UNIX_TIMESTAMP(),'%s')",
				array(bigintval(REQUEST_POST('to_uid')), getUserId(), bigintval(REQUEST_POST('points')), REQUEST_POST('reason'), __TRANS_ID),
				__FILE__, __LINE__);
			SQL_QUERY_ESC("INSERT INTO `{!_MYSQL_PREFIX!}_user_transfers_out` (userid, to_uid, points, reason, time_trans, trans_id) VALUES ('%s','%s','%s','%s', UNIX_TIMESTAMP(),'%s')",
				array(getUserId(), bigintval(REQUEST_POST('to_uid')), bigintval(REQUEST_POST('points')), REQUEST_POST('reason'), __TRANS_ID),
				__FILE__, __LINE__);

			// Add points to account *directly* ...
			ADD_POINTS_REFSYSTEM("member_transfer", bigintval(REQUEST_POST('to_uid')), bigintval(REQUEST_POST('points')), false, "0", false, "direct");

			// ... and add it to current user's used points
			SUB_POINTS('transfer', getUserId(), REQUEST_POST('points'));

			// First send email to recipient
			$msg = LOAD_EMAIL_TEMPLATE("member_transfer_recipient", '', constant('__RECIPIENT_UID'));
			SEND_EMAIL(constant('__RECIPIENT_EMAIL'), getMessage('TRANSFER_MEMBER_RECIPIENT_SUBJ').": ".$SENDER, $msg);

			// Second send email to sender
			$msg = LOAD_EMAIL_TEMPLATE("member_transfer_sender", '', constant('__SENDER_UID'));
			SEND_EMAIL(constant('__SENDER_EMAIL'), getMessage('TRANSFER_MEMBER_SENDER_SUBJ').": ".$RECIPIENT, $msg);

			// At last send admin mail(s)
			$ADMIN_SUBJ = sprintf("%s (%s->%s)", getMessage('TRANSFER_ADMIN_SUBJECT'), $SENDER, $RECIPIENT);
			SEND_ADMIN_NOTIFICATION($ADMIN_SUBJ, "admin_transfer_points");

			// Transfer is completed
			LOAD_TEMPLATE('admin_settings_saved', false, getMessage('TRANSFER_COMPLETED')."<br /><a href=\"{!URL!}/modules.php?module=login&amp;what=transfer\">{--TRANSFER_CONTINUE_OVERVIEW--}</a>");
		} elseif (!$valid_code) {
			// Invalid Touring code!
			LOAD_TEMPLATE('admin_settings_saved', false, "<div class=\"member_note\">{--TRANSFER_INVALID_CODE--}</div>");
			REQUEST_UNSET_POST('ok');
		} elseif (!$valid_pass) {
			// Wrong password entered
			LOAD_TEMPLATE('admin_settings_saved', false, "<div class=\"member_note\">{--TRANSFER_INVALID_PASSWORD--}</div>");
			REQUEST_UNSET_POST('ok');
		} elseif (!$valid_amount) {
			// Too much points entered
			LOAD_TEMPLATE('admin_settings_saved', false, "<div class=\"member_note\">{--TRANSFER_INVALID_POINTS--}</div>");
			REQUEST_UNSET_POST('ok');
		} elseif (!$valid_reason) {
			// No transfer reason entered
			LOAD_TEMPLATE('admin_settings_saved', false, "<div class=\"member_note\">{--TRANSFER_INVALID_REASON--}</div>");
			REQUEST_UNSET_POST('ok');
		} elseif (!$valid_recipient) {
			// No recipient selected
			LOAD_TEMPLATE('admin_settings_saved', false, "<div class=\"member_note\">{--TRANSFER_INVALID_RECIPIENT--}</div>");
			REQUEST_UNSET_POST('ok');
		} elseif (!$valid_data) {
			// No recipient selected
			LOAD_TEMPLATE('admin_settings_saved', false, "<div class=\"member_note\">{--TRANSFER_INVALID_DATA--}</div>");
			REQUEST_UNSET_POST('ok');
		}
	}

	if (!IS_FORM_SENT()) {
		// Load member list
		if (EXT_IS_ACTIVE('nickname')) {
			// Load userid and nickname
			$result = SQL_QUERY_ESC("SELECT userid, nickname FROM `{!_MYSQL_PREFIX!}_user_data` WHERE `status`='CONFIRMED' AND opt_in='Y' AND userid != '%s' ORDER BY userid",
			 array(getUserId()), __FILE__, __LINE__);
		} else {
			// Load only userid
			$result = SQL_QUERY_ESC("SELECT userid, userid FROM `{!_MYSQL_PREFIX!}_user_data` WHERE `status`='CONFIRMED' AND opt_in='Y' AND userid != '%s' ORDER BY userid",
			 array(getUserId()), __FILE__, __LINE__);
		}

		if (SQL_NUMROWS($result) > 0) {
			// Load list
			$OUT  = "<select name=\"to_uid\" size=\"1\" class=\"member_select\">
	<option value=\"0\">{--SELECT_NONE--}</option>\n";
			// @TODO Try to rewrite his to $content = SQL_FETCHARRAY(), see some lines above for two different queries
			while (list($uid, $nick) = SQL_FETCHROW($result)) {
				$OUT .= "	<option value=\"".$uid."\"";
				if ((REQUEST_ISSET_POST(('to_uid'))) && (REQUEST_POST('to_uid') == $uid)) $OUT .= ' selected="selected"';
				$OUT .= ">";
				if (($nick != $uid) && (!empty($nick))) {
					// Output nickname
					$OUT .= $nick;
				} else {
					// Output userid
					$OUT .= $uid;
				}
				$OUT .= "</option>\n";
			}
			$OUT .= "</select>\n";
			define('__TRANSFER_TO_DISABLED', '');

			// Free memory
			SQL_FREERESULT($result);
		} else {
			// No one else is opt-in
			$OUT = getMessage('TRANSFER_NO_ONE_ELSE_OPT_IN');
			define('__TRANSFER_TO_DISABLED', " disabled");
		}

		// Transfer output to constant for the template
		define('__TRANSFER_USERID_SELECTION', $OUT);

		// Generate Code
		if (getConfig('transfer_code') > 0) {
			$rand = mt_rand(0, 99999);
			$code = generateRandomCodde(getConfig('transfer_code'), $rand, getUserId(), constant('__TRANSFER_MAX_VALUE'));
			$img = GENERATE_IMAGE($code, false);
			define('__TRANSFER_IMAGE_INPUT', "<input type=\"hidden\" name=\"code_chk\" value=\"".$rand."\" /><input type=\"text\" name=\"code\" class=\"member_normal\" size=\"5\" maxlength=\"7\"{!__TRANSFER_TO_DISABLED!} />&nbsp;".$img);
		} else {
			$code = "00000";
			define('__TRANSFER_IMAGE_INPUT', getMessage('TRANSFER_NO_CODE'));
		}

		// Transfer maybe already entered valued'
		if (REQUEST_ISSET_GET('ok')) {
			// Get values from form
			define('__TRANSFER_POINTS_VALUE', bigintval(REQUEST_POST('points')));
			define('__TRANSFER_REASON_VALUE', strip_tags(REQUEST_POST('reason')));
		} else {
			// Set empty values
			define('__TRANSFER_POINTS_VALUE', '');
			define('__TRANSFER_REASON_VALUE', '');
		}

		// Output form
		LOAD_TEMPLATE("member_transfer_new");
	}
	break;

case "list_in": // List only incoming transactions
case "list_out": // List only outgoing transactions
	// As you can see I put list_in and list_out together. I now do a switch() again on it for the right SQL command
	switch ($mode)
	{
	case "list_in":
		$sql = "SELECT trans_id, from_uid, points, reason, time_trans FROM `{!_MYSQL_PREFIX!}_user_transfers_in` WHERE userid=%s ORDER BY time_trans DESC LIMIT ".getConfig('transfer_max');
		// @TODO Rewrite these constants
		$NOTHING = getMessage('TRANSFER_NO_INCOMING_TRANSFERS');
		define('__TRANSFER_SUM', getMessage('TRANSFER_TOTAL_INCOMING'));
		define('__TRANSFER_TITLE', getMessage('TRANSFER_LIST_INCOMING'));
		break;

	case "list_out":
		$sql = "SELECT trans_id, to_uid, points, reason, time_trans FROM `{!_MYSQL_PREFIX!}_user_transfers_out` WHERE userid=%s ORDER BY time_trans DESC LIMIT ".getConfig('transfer_max');
		// @TODO Rewrite these constants
		$NOTHING = getMessage('TRANSFER_NO_OUTGOING_TRANSFERS');
		define('__TRANSFER_SUM', getMessage('TRANSFER_TOTAL_OUTGOING'));
		define('__TRANSFER_TITLE', getMessage('TRANSFER_LIST_OUTGOING'));
		break;
	}

	// Run the SQL command
	$total = 0;
	$result = SQL_QUERY_ESC($sql, array(getUserId()), __FILE__, __LINE__);
	if (SQL_NUMROWS($result) > 0) {
		$OUT = ''; $SW = 2;
		// @TODO This should be somehow rewritten to $content = SQL_FETCHARRAY(), see switch() block above for SQL queries
		while (list($tid, $uid, $points, $reason, $stamp) = SQL_FETCHROW($result)) {
			// Rewrite points
			if ($type == "OUT") $points = $points."-";

			// Prepare content for template
			$content = array(
				'sw'     => $SW,
				'tid'    => $id,
				'stamp'  => MAKE_DATETIME($stamp, "3"),
				'uid'    => $uid,
				'reason' => $reason,
				'points' => TRANSLATE_COMMA($points)
			);

			// Load row template
			$OUT .= LOAD_TEMPLATE("member_transfer_row2", true, $content);

			// Add points and switch color
			$total += $points;
			$SW = 3 - $SW;
		}

		// Free memory
		SQL_FREERESULT($result);
	} else {
		// Nothing for in or out
		$OUT = "<tr>
  <td colspan=\"5\" align=\"center\" class=\"bottom2\" height=\"70\">
    ".LOAD_TEMPLATE('admin_settings_saved', true, $NOTHING)."
  </td>
</tr>";
	}

	// ... and add them to a constant for the template
	// @TODO Rewrite these constants
	define('__TRANSFER_ROWS', $OUT);

	// Remeber total amount
	define('__TRANSFER_TOTAL_VALUE', $total);

	// Load final template
	LOAD_TEMPLATE("member_transfer_list");
	break;

case "list_all": // List all transactions
	// We fill a temporary table with data from both tables. This is much easier
	// to code and unstand by you as sub-SELECT queries. I know this is not the
	// fastest way but it shall be fine for now.
	//
	// First of all create the temporary table
	$result = SQL_QUERY("CREATE TEMPORARY TABLE `{!_MYSQL_PREFIX!}_transfers_tmp` (
trans_id VARCHAR(12) NOT NULL DEFAULT '',
party_uid BIGINT(20) UNSIGNED NOT NULL DEFAULT '0',
points BIGINT(20) UNSIGNED NOT NULL DEFAULT '0',
reason VARCHAR(255) NOT NULL DEFAULT '',
time_trans VARCHAR(10) NOT NULL DEFAULT '0',
trans_type ENUM('IN','OUT') NOT NULL DEFAULT 'IN',
KEY(party_uid)
) TYPE=HEAP", __FILE__, __LINE__);

	// Let's begin with the incoming list
	$result = SQL_QUERY_ESC("SELECT trans_id, from_uid, points, reason, time_trans FROM `{!_MYSQL_PREFIX!}_user_transfers_in` WHERE userid=%s ORDER BY `id` LIMIT %s",
array(getUserId(), getConfig('transfer_max')), __FILE__, __LINE__);
	while ($DATA = SQL_FETCHROW($result)) {
		$DATA[] = "IN";
		$DATA = implode("','", $DATA);
		$res_temp = SQL_QUERY("INSERT INTO `{!_MYSQL_PREFIX!}_transfers_tmp` (trans_id, party_uid, points, reason, time_trans, trans_type) VALUES ('".$DATA."')", __FILE__, __LINE__);
	}

	// Free memory
	SQL_FREERESULT($result);

	// As the last table transfer data from outgoing table to temporary
	$result = SQL_QUERY_ESC("SELECT trans_id, to_uid, points, reason, time_trans FROM `{!_MYSQL_PREFIX!}_user_transfers_out` WHERE userid=%s ORDER BY `id` LIMIT %s",
array(getUserId(), getConfig('transfer_max')), __FILE__, __LINE__);
	while ($DATA = SQL_FETCHROW($result)) {
		$DATA[] = "OUT";
		$DATA = implode("','", $DATA);
		$res_temp = SQL_QUERY("INSERT INTO `{!_MYSQL_PREFIX!}_transfers_tmp` (trans_id, party_uid, points, reason, time_trans, trans_type) VALUES ('".$DATA."')", __FILE__, __LINE__);
	}

	// Free memory
	SQL_FREERESULT($result);

	$total = 0;
	if (SQL_NUMROWS($result) > 0) {
		// Search for entries
		$result = SQL_QUERY("SELECT party_uid, trans_id, points, reason, time_trans, trans_type FROM `{!_MYSQL_PREFIX!}_transfers_tmp` ORDER BY time_trans DESC",
			__FILE__, __LINE__);

		// Output rows
		$OUT = ''; $SW = 2;
		while ($content = SQL_FETCHARRAY($result)) {
			// Rewrite points
			if ($content['trans_type'] == "OUT") $content['points'] = "-".$content['points']."";

			// Prepare content for template
			$content['sw']     = $SW;
			$content['time']   = MAKE_DATETIME($content['time_trans'], "3");
			$content['points'] = TRANSLATE_COMMA($content['points']);

			// Load row template
			$OUT .= LOAD_TEMPLATE("member_transfer_row", true, $content);

			// Add points and switch color
			$total += $content['points'];
			$SW = 3 - $SW;
		}

		// Free memory
		SQL_FREERESULT($result);
	} else {
		// Nothing for in and out
		$OUT = "<tr>
  <td colspan=\"5\" align=\"center\" class=\"bottom2\" height=\"70\">
    ".LOAD_TEMPLATE('admin_settings_saved', true, getMessage('TRANSFER_NO_INOUT_TRANSFERS'))."
  </td>
</tr>";
	}

	// ... and add them to a constant for the template
	// @TODO Rewrite all these constants
	define('__TRANSFER_ROWS', $OUT);

	// Remeber total amount
	define('__TRANSFER_TOTAL_VALUE', $total);

	// Set title
	define('__TRANSFER_TITLE', getMessage('TRANSFER_LIST_ALL'));

	// Set "balance" word
	define('__TRANSFER_SUM', getMessage('TRANSFER_TOTAL_BALANCE'));

	// Load final template
	LOAD_TEMPLATE("member_transfer_list");

	// At the end we don't need a temporary table in memory
	$result = SQL_QUERY("DROP TABLE IF EXISTS `{!_MYSQL_PREFIX!}_transfers_tmp`", __FILE__, __LINE__);

	// Free some memory...
	SQL_FREERESULT($result);
	break;

case "": // Overview page
	// Check incoming transfers
	$result = SQL_QUERY_ESC("SELECT COUNT(id) FROM `{!_MYSQL_PREFIX!}_user_transfers_in` WHERE userid=%s", array(getUserId()), __FILE__, __LINE__);
	list($dmy) = SQL_FETCHROW($result);
	SQL_FREERESULT($result);

	$total=$dmy;
	if ($dmy > 0) {
		define('__TRANSFER_IN_LINK', "<a href=\"{!URL!}/modules.php?module=login&amp;what=transfer&amp;mode=list_in\">".$dmy."</a>");
	} else {
		define('__TRANSFER_IN_LINK', $dmy);
	}

	// Check outgoing transfers
	$result = SQL_QUERY_ESC("SELECT COUNT(id) FROM `{!_MYSQL_PREFIX!}_user_transfers_out` WHERE userid=%s", array(getUserId()), __FILE__, __LINE__);
	list($dmy) = SQL_FETCHROW($result);
	SQL_FREERESULT($result);

	$total+=$dmy;
	if ($dmy > 0) {
		define('__TRANSFER_OUT_LINK', "<a href=\"{!URL!}/modules.php?module=login&amp;what=transfer&amp;mode=list_out\">".$dmy."</a>");
	} else {
		define('__TRANSFER_OUT_LINK', $dmy);
	}

	// Total transactions
	if ($total > 0) {
		define('__TRANSFER_ALL_LINK', "<a href=\"{!URL!}/modules.php?module=login&amp;what=transfer&amp;mode=list_all\">".$total."</a>");
	} else {
		define('__TRANSFER_ALL_LINK', $total);
	}

	if (IS_FORM_SENT()) {
		// Save settings
		SQL_QUERY_ESC("UPDATE `{!_MYSQL_PREFIX!}_user_data` SET opt_in='%s' WHERE userid=%s LIMIT 1",
			array(REQUEST_POST('opt_in'), getUserId()), __FILE__, __LINE__);

		// Rember for next switch() command
		$opt_in = REQUEST_POST('opt_in');

		// "Settings saved..."
		LOAD_TEMPLATE('admin_settings_saved', false, "<div class=\"member_done\">{--SETTINGS_SAVED--}</div>");
	}

	switch ($opt_in)
	{
	case 'Y':
		define('__TRANSFER_ALLOW_Y', ' chkecked="checked"');
		define('__TRANSFER_ALLOW_N', '');
		define('__TRANSFER_NEW_LINK', "<a href=\"{!URL!}/modules.php?module=login&amp;what=transfer&amp;mode=new\">{--TRANSFER_NOW_LINK--}</a>");
		break;

	case 'N':
		define('__TRANSFER_ALLOW_Y', '');
		define('__TRANSFER_ALLOW_N', ' chkecked="checked"');
		define('__TRANSFER_NEW_LINK', getMessage('TRANSFER_PLEASE_ALLOW_OPT_IN'));
		break;
	}

	// Check for latest out-transfers
	$result = SQL_QUERY_ESC("SELECT time_trans
FROM `{!_MYSQL_PREFIX!}_user_transfers_out`
WHERE time_trans > (UNIX_TIMESTAMP() - %s) AND userid=%s
ORDER BY time_trans DESC
LIMIT 1", array(getConfig('transfer_timeout'), getUserId()), __FILE__, __LINE__);
	if (SQL_NUMROWS($result) == 0) {
		// Load template
		define('__TRANSFER_SETTINGS_CONTENT', LOAD_TEMPLATE("member_transfer_settings", true));
	} else {
		// Load newest transaction
		list($newest) = SQL_FETCHROW($result);
		SQL_FREERESULT($result);
		define('__TRANSFER_SETTINGS_CONTENT', sprintf(getMessage('TRANSFER_LATEST_IS'), MAKE_DATETIME($newest, "3")));
	}

	// Load template
	LOAD_TEMPLATE("member_transfer_overview");
	break;
}
//
?>
